signature PRINT =
sig

  (* print an expression *)
  val expToString : Syntax.exp -> string
end

structure Print :> PRINT = 
struct

  open Syntax

  fun exp0 (tab, e) = case e
       of Plus(e1, e2) =>
              exp0 (tab, e1) ^ " + " ^ expinf (tab, e2)
	| Cat(e1, e2) =>
	      exp0 (tab, e1) ^ " ^ " ^ expinf (tab, e2)
	| _ => expinf (tab, e)

  and expinf (tab, e) = case e
       of Num(k) => Int.toString k
	| Str(s) => "\"" ^ s ^ "\""
        | Var(x) => x
        | Let(e1, x, e2) =>
              let val tab' = tab ^ "    "
              in "let " ^ x ^ " be " ^ exp0 (tab, e1) ^ " in" ^
                 tab' ^ exp0 (tab', e2) ^
                 tab ^ "end" end
        | _ => "(" ^ exp0 (tab, e) ^ ")"

  fun expToString t = exp0 ("\n", t)

end;  (* functor PrintFun *)
